ARG IMAGE_NAME
FROM ${IMAGE_NAME}:{{ cuda.version.release_label }}-base-{{ cuda.os.distro }}{{ cuda.os.version }}{{ cuda.image_tag_suffix if "image_tag_suffix" in cuda }}

LABEL maintainer "NVIDIA CORPORATION <cudatools@nvidia.com>"

{# To add a new package and have it detected by the automation, set it here as <package_name_with_underscores>_component_version #}
{% set std_version = cuda.version.major + "-" + cuda.version.minor + "=" + cuda.version.release_label + "-1" -%}
{% set cuda_nvtx_component_version = cuda.version.major + "-" + cuda.version.minor + "=" + cuda.components.nvtx.version -%}
{% set libnpp_component_version = cuda.version.major + "-" + cuda.version.minor + "=" + cuda.components.libnpp.version %}
{% set libcusparse_component_version = cuda.version.major + "-" + cuda.version.minor + "=" + cuda.components.libcusparse.version %}
{% set libcublas_component_version = cuda.components.libcublas.version %}
{% set libcublas_pkg_name = "libcublas-" + cuda.version.major + "-" + cuda.version.minor -%}

{# L4T uses older packaging name format for libcublas #}
{%- if cuda.version.major_minor in ["10.2"] %}
    {% set libcublas_pkg_name = "libcublas10" %}
    {% set libcublas_component_version = cuda.components.libcublas.version %}
{% endif -%}

{% if "libnccl2" in cuda.components and cuda.components.libnccl2 %}
    {% set libnccl2_component_version = cuda.components.libnccl2.version %}
ENV NCCL_VERSION {{ libnccl2_component_version[:-2] }}

{% endif -%}

RUN apt-get update && apt-get install -y --no-install-recommends \
    cuda-libraries-{{ std_version }} \
    libnpp-{{ libnpp_component_version }} \
    cuda-nvtx-{{ cuda_nvtx_component_version }} \
    {{ libcublas_pkg_name }}={{ libcublas_component_version }} \
    libcusparse-{{ libcusparse_component_version }} \
    {% if "libnccl2" in cuda.components and (cuda.components.libnccl2 and "source" not in cuda.components.libnccl2) %}
    libnccl2=$NCCL_VERSION-1+cuda{{ cuda.version.major }}.{{ cuda.version.minor }} \
    {% endif %}
    && rm -rf /var/lib/apt/lists/*

# apt from auto upgrading the cublas package. See https://gitlab.com/nvidia/container-images/cuda/-/issues/88
RUN apt-mark hold {{ libcublas_pkg_name }}{% if libnccl2_component_version and (cuda.components.libnccl2 and not "source" in cuda.components.libnccl2) %} libnccl2{% endif %}

{% if "libnccl2" in cuda.components and (cuda.components.libnccl2 and "source" in cuda.components.libnccl2) %}
    {% set arch = cuda.arch %}
    {% if cuda.arch == "arm64" %} {% set arch = "aarch64" %} {% endif %}
    {% set basename =  "nccl_" + cuda.components.libnccl2.version + "-1+cuda" + cuda.version.major + "." + cuda.version.minor + "_" + arch + ".txz" %}
RUN apt update && apt install curl xz-utils -y --no-install-recommends && NCCL_DOWNLOAD_SUM={{ cuda.components.libnccl2.sha256sum }} && \
    curl -fsSL {{ cuda.components.libnccl2.source }} -O && \
    echo "$NCCL_DOWNLOAD_SUM  {{ basename }}" | sha256sum -c - && \
    tar --no-same-owner --keep-old-files --lzma -xvf {{ basename }} -C /usr/local/cuda/lib64/ --strip-components=2 --wildcards '*/lib/libnccl.so.*' && \
    tar --no-same-owner --keep-old-files --lzma -xvf  {{ basename }} -C /usr/lib/pkgconfig/ --strip-components=3 --wildcards '*/lib/pkgconfig/*' && \
    rm {{ basename }} && \
    ldconfig && rm -rf /var/lib/apt/lists/*
{% endif %}
